#include<stdio.h>
#include<stdlib.h>
#include<X11/Xlib.h>
#include<math.h>
#include<unistd.h>
#include<string.h>
#include<signal.h>


#ifndef MUSTPU_H
#include "mustpu.h"
#endif

XKeyboardState initkbstate;
Display *display;

void set_bell(int pitch,int duration)
{
  XKeyboardControl changes;
  changes.bell_duration=duration;
  changes.bell_pitch=pitch;
  XChangeKeyboardControl(display,KBBellDuration|KBBellPitch,&changes);
}

void stophandle(int signo)
{
  signal(signo,SIG_IGN);
  set_bell(initkbstate.bell_pitch,initkbstate.bell_duration);
  XCloseDisplay(display);
  exit(signo+128);
}

void susphandle(int signo)
{
  signal(signo,SIG_IGN);
  set_bell(initkbstate.bell_pitch,initkbstate.bell_duration);
  XFlush(display);
  signal(signo,SIG_DFL);
  raise(signo);
  signal(signo,susphandle);
}

void play(int freq,int duration,int volume)
{
  set_bell(freq,duration);
  XBell(display,volume);
  XFlush(display);
  usleep(duration*1000L);
}

int main(argc, argv)
int argc;
char *argv[];
{
  FILE *f;
  char s[2048];
  char *p;
  int freq,dura;
  int duration;
  int volume;  

  switch(argc){
  	case 1:
		duration=150;
		volume=100;
		printf("%s: X11 music player, (c) Vladimir Dergachev,1999 (GPL)\n",argv[0]);
		printf("Usage:\n");
		printf("\t%s [filename=ask [base_duration=150 [volume=100]]]\n",argv[0]);
		printf("\n");
		printf("What file would you want to play? ");
		fgets(s,2000,stdin);
		for(p=s;*p && (*p!='\n'); p++);
		if(*p=='\n')*p=0;
		break;
	case 2: duration=150;
		volume=100;
		sprintf(s,"%s",argv[1]);
		break;
	case 3: duration=atoi(argv[2]);
		volume=100;
		sprintf(s,"%s",argv[1]);
		break;
	case 4: duration=atoi(argv[2]);
		volume=atoi(argv[3]);
		sprintf(s,"%s",argv[1]);
		break;
	default:
		break;
  }

  f = fopen(s,"r");
  if(f==NULL){
  	perror(argv[1]);
	return(-1);
	}

  if (!(display=XOpenDisplay(getenv("DISPLAY")))) {
    fprintf(stderr,"Can't open display\n");
    return(-1);
  }
  XGetKeyboardControl(display,&initkbstate);
  signal(SIGHUP,stophandle);
  signal(SIGINT,stophandle);
  signal(SIGTERM,stophandle);
  signal(SIGTSTP,susphandle);
	
  while (!feof(f)) {
  	fgets(s,2000,f);
	if(s[0]=='%')continue;
	if(s[0]=='\n')continue;
	if(s[0]==0)continue;
	for(p=s;*p && (*p!='-');p++);
	if(*p=='-'){
		*p=0;
		p++;
		}
	Freq(s,&freq);
	dura=atoi(p);
	play(freq,duration*dura,volume);
  	}
  if (f != NULL)
    fclose(f);
  set_bell(initkbstate.bell_pitch,initkbstate.bell_duration);
  XCloseDisplay(display);
  return(0);
 }
